N,K,T = map(int,input().split())
MOD = 1000000007

def modular_power(a,m) :
    res = 1
    while m > 0 :
        if ((m&1) > 0) :
            res = (res*a)%MOD
        m   = m >> 1
        a = (a*a)%MOD
    return res

def inverse(a) :
    return modular_power(a,MOD-2)

def factorial(n) :
    res = 1
    for i in range(2,n+1) :
        res = (res * i) % MOD
    return res

def number_of_permutations(n,partition) :
    numerator = factorial(n)
    denominator = 1
    for i in range(1,n+1) :
        if partition[i] > 0 :
            factor = (modular_power(i,partition[i]) * factorial(partition[i]))%MOD
            denominator = (denominator*factor)%MOD
    return (numerator*inverse(denominator))%MOD

def permutation_to_partition(pi) :
    n = len(pi)
    res = [0]*(n)
    visited = set()
    for k in range(1,n) :
        i = pi[k]
        if i in visited : continue
        visited.add(i)
        cnt = 1
        pos = pi[i]
        while pos != i :
            cnt += 1
            visited.add(pos)
            pos = pi[pos]
        res[cnt] += 1
    return res

def solve(n,k):
    dp = {}
    dp[tuple([0,n]+[0]*(n-1))] = 1
    for i in range(k) :
        dp_next = {}
        for oldpartition_tuple in dp :
            cnt = dp[oldpartition_tuple] % MOD
            oldpartition = list(oldpartition_tuple)
            for a in range(1,n+1) :
                if oldpartition_tuple[a] > 0 :
                    for b in range(a+1,n+1) :
                        if oldpartition_tuple[b] > 0 :
                            oldpartition[a] -= 1
                            oldpartition[b] -= 1
                            oldpartition[a+b] += 1
                            newpartition = tuple(oldpartition)
                            if newpartition in dp_next :
                                dp_next[newpartition] += oldpartition_tuple[a]*oldpartition_tuple[b]*a*b * cnt 
                            else :
                                dp_next[newpartition] = oldpartition_tuple[a]*oldpartition_tuple[b]*a*b * cnt  
                            oldpartition[a] += 1
                            oldpartition[b] += 1
                            oldpartition[a+b] -= 1

            for a in range(1,n+1) :
                if oldpartition_tuple[a] > 0 :
                    for k in range(1,1+a//2) :
                        oldpartition[a] -= 1
                        oldpartition[k] += 1
                        oldpartition[a-k] += 1
                        newpartition = tuple(oldpartition)
                        factor = a
                        if (a%2 == 0) and k == a//2  :
                            factor = a//2
                        if newpartition in dp_next :
                            dp_next[newpartition] += oldpartition_tuple[a] * factor * cnt
                        else :
                            dp_next[newpartition] = oldpartition_tuple[a] * factor * cnt
                        oldpartition[a] += 1
                        oldpartition[k] -= 1
                        oldpartition[a-k] -= 1
                    if oldpartition_tuple[a] > 1 :
                        oldpartition[a] -= 2
                        oldpartition[2*a] += 1
                        newpartition = tuple(oldpartition)
                        if newpartition in dp_next :
                            dp_next[newpartition] += a*a * cnt  * (oldpartition_tuple[a]*(oldpartition_tuple[a]-1))//2
                        else :
                            dp_next[newpartition] = a*a * cnt * (oldpartition_tuple[a]*(oldpartition_tuple[a]-1))//2
                        oldpartition[a] += 2
                        oldpartition[2*a] -= 1
        dp = dp_next
    for partition in dp :
        res = dp[partition] % MOD
        res *= inverse(number_of_permutations(N,partition))
        res %= MOD
        dp[partition] = res
    return dp

dp = solve(N,K)

for i in range(T):
    pi = [0] + list(map(int,input().split()))
    partition = tuple(permutation_to_partition(pi))
    if partition not in dp :
        print(0)
    else :
        print(dp[tuple(partition)])

